
const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

	let x,y,t,xp,f1;
	let v;
	let dv;
	let av;
	let f;
	let r;
	let d = { width: canvas.width, height: canvas.height };


function init() {
	    v=0;
		f=1;
		av=20;	
		dv=av;
		r=20;
		
         buffer = createBuffer(d.width, d.height);
         drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
        const g = buffer.getContext("2d");
			g.fillStyle = "white";
		    g.fillRect(0,0,d.width,d.height);
				
	  for (t=v;t<=d.width*10+50;t=t+2){			
            y=d.height/2+40*Math.cos(2*t*3.14159*2/360);
		    x=0.1*t-10*Math.sin(2*t*3.14159*2/360);//15　固定波
		    if(t>=400){
			g.fillStyle = "blue";		
		    g.fillRect(x,y,2,4);//3,6
		}
		}
          if(v<=d.width*10+50){
          for (t=400;t<=v;t=t+2){			
			
	      y=d.height/2+40*Math.cos(2*t*3.14159*2/360);
		  x=0.1*t-10*Math.sin(2*t*3.14159*2/360)-18*Math.sin((t-v)*2*3.1415*2/5000);//進行波
          xp=-40-18*Math.sin((400-v)*2*3.1415*2/5000);
		  g.fillStyle = "blue";
		  g.fillRect(x,y,2,4);//3,6
 		  g.fillStyle = "black";
		  g.fillRect(xp,d.height/2-10,70,20);
		  }
	        }

         if(v>d.width*10+50){
          for (t=400;t<=d.width*10+50;t=t+2){			
			
	       y=d.height/2+40*Math.cos(2*t*3.14159*2/360);		
		   x=0.1*t-10*Math.sin(2*t*3.14159*2/360)-18*Math.sin((t-v)*2*3.1415*2/5000);//進行波 、v の増加による減衰を抑える
           xp=-40-18*Math.sin((400-v)*2*3.1415*2/5000);
		g.fillStyle = "blue";
		g.fillRect(x,y,2,4);//3,6
 		g.fillStyle = "black";
		g.fillRect(xp,d.height/2-10,70,20);
		}
	        }
	}
	
function move() {
	        dv=f*av;
		    v=v+dv; 
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
		ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 20);
}


document.getElementById('Run').addEventListener('click', Run);
document.getElementById('Stop').addEventListener('click', Stop);
document.getElementById('Reset').addEventListener('click', Reset);


function Run() {
       f=1;
			
}
function Stop() {
       av=0;				
						
}
function Reset() {
         f=0;v=0;av=20;dv=av;
}


init();
start();




